> module Interval where

> type Interval a = (Maybe a, Maybe a)

> range a b = (Just a, Just b)
> everything = (Nothing, Nothing)
> from x = (Just x, Nothing)
> till x = (Nothing, Just x)

> itest l r x (a, b) = maybe l (<= x) a && maybe r (>= x) b

> inside :: (Ord a) => a -> Interval a -> Bool
> inside = itest True True

> subinterval (a, b) (c, d) = itest True False a (c, d) && itest False True b (c, d)

